#!/usr/bin/env python
import rospy
from std_msgs.msg import Float32MultiArray
from std_msgs.msg import Int32MultiArray
import time as t

#data_array
DATA_RECEIVE = 2
DATA_SEND = 4
array = [0] * DATA_RECEIVE
row = [0] * DATA_SEND
#param

wheel_rad = 0.028
wheel_sep = 0.2
speed_ang = 0.0
speed_lin = 0.0
gain = 40
r_gain = 1.1
rl_gain=1
MAX = 255
MIN = 60
ignore_range = 0.02

def init():
	rospy.init_node('calculater')
	rospy.Subscriber("vel_data_to_cal", Float32MultiArray, callback,queue_size=20)
	while not rospy.is_shutdown():
		t = 1
	modify(0,0)
def callback(data):
	speed_ang = -1 * data.data[0];
  	speed_lin = data.data[1];
	if(abs(speed_ang) < ignore_range):
		speed_ang = 0
  	w_r = (speed_lin/wheel_rad) + r_gain*((speed_ang*wheel_sep)/(2.0*wheel_rad));
  	w_l = (speed_lin/wheel_rad) - r_gain*((speed_ang*wheel_sep)/(2.0*wheel_rad));
	modify(w_r,w_l)
def modify(wr,wl):
	r = abs(int(gain * wr))
	l = abs(int(gain * wl))
	if(wr >= 0):
		row[0]=0
	else:
		row[0]=1
	if(wl >= 0):
		row[2]=0
	else:
		row[2]=1
	if(r > MAX):
		r = MAX
	if(l > MAX):
		l = MAX
	if(r < MIN and l < MIN and r != 0 and l != 0):
		r = MIN
		l = MIN
	row[1] = int(r)*rl_gain
	row[3] = int(l)
	rospy.loginfo(row)
	if r >= 0 & l >= 0:
		pub = rospy.Publisher("vel_data_to_i2c",Int32MultiArray, queue_size=20)
		forpub = Int32MultiArray(data=row)
		pub.publish(forpub)

if __name__=='__main__':
	init()

