#!/usr/bin/env python
import rospy
from std_msgs.msg import Int32MultiArray,Int32
import Jetson.GPIO as GPIO
import smbus
import time as t
i2c = smbus.SMBus(1)

addr = 0x27
key = 0x76
DATA_NUM = 6
array = [0] * DATA_NUM
row = [0] * DATA_NUM
mode = 0
pubed = 0
def init():
	global row ,pubed,mode
	rospy.init_node('i2c_sender')
	try:
		i2c.write_i2c_block_data(addr, key, row)
	except IOError:
		t.sleep(0.1)
	rospy.Subscriber("vel_data_to_i2c",Int32MultiArray,callback, queue_size=20)
	rospy.Subscriber("rot_value",Int32,rotmode, queue_size=20)
	pub = rospy.Publisher("Run_Mode",Int32, queue_size=5)
	while not rospy.is_shutdown():
		t.sleep(0.1)
		try:
			i2c.write_i2c_block_data(addr, key, row)
			mode = int(i2c.read_byte_data(addr,key))
			pub.publish(mode)
			rospy.logwarn(row)
			if pubed == 1:
				row[5] = 0
				pubed = 0
		except IOError:
			rospy.loginfo('IOERROR')
			rospy.loginfo(row)
def rotmode(data):
	global row
	row[5] = data.data
	rospy.logwarn(data)
	pubed = 1
def callback(data):
	global row
	for i in range(4):
		row[i] = data.data[i]

if __name__=='__main__':
	init()
